package org.dromara.elevator.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.dromara.elevator.domain.EMaintenanceRecord;
import org.springframework.stereotype.Service;
import org.dromara.elevator.domain.bo.EOtherMaintainRecordBo;
import org.dromara.elevator.domain.vo.EOtherMaintainRecordVo;
import org.dromara.elevator.domain.EOtherMaintainRecord;
import org.dromara.elevator.mapper.EOtherMaintainRecordMapper;
import org.dromara.elevator.service.IEOtherMaintainRecordService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 维修救援等记录;Service业务层处理
 *
 * @author zy
 * @date 2024-07-29
 */
@RequiredArgsConstructor
@Service
public class EOtherMaintainRecordServiceImpl implements IEOtherMaintainRecordService {

    private final EOtherMaintainRecordMapper baseMapper;

    /**
     * 查询维修救援等记录;
     *
     * @param id 主键
     * @return 维修救援等记录;
     */
    @Override
    public EOtherMaintainRecordVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询维修救援等记录;列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 维修救援等记录;分页列表
     */
    @Override
    public TableDataInfo<EOtherMaintainRecordVo> queryPageList(EOtherMaintainRecordBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<EOtherMaintainRecord> lqw = buildQueryWrapper(bo);
        Page<EOtherMaintainRecordVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的维修救援等记录;列表
     *
     * @param bo 查询条件
     * @return 维修救援等记录;列表
     */
    @Override
    public List<EOtherMaintainRecordVo> queryList(EOtherMaintainRecordBo bo) {
        LambdaQueryWrapper<EOtherMaintainRecord> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<EOtherMaintainRecord> buildQueryWrapper(EOtherMaintainRecordBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<EOtherMaintainRecord> lqw = Wrappers.lambdaQuery();
        lqw.eq(StringUtils.isNotBlank(bo.getElevatorNum()), EOtherMaintainRecord::getElevatorNum, bo.getElevatorNum());
        lqw.eq(StringUtils.isNotBlank(bo.getCreator()), EOtherMaintainRecord::getCreator, bo.getCreator());
        lqw.eq(StringUtils.isNotBlank(bo.getDescription()), EOtherMaintainRecord::getDescription, bo.getDescription());
        lqw.eq(bo.getPlanTime() != null, EOtherMaintainRecord::getPlanTime, bo.getPlanTime());
        lqw.eq(bo.getType() != null, EOtherMaintainRecord::getType, bo.getType());
        lqw.orderByDesc(EOtherMaintainRecord::getCreateTime);
        return lqw;
    }

    /**
     * 新增维修救援等记录;
     *
     * @param bo 维修救援等记录;
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(EOtherMaintainRecordBo bo) {
        EOtherMaintainRecord add = MapstructUtils.convert(bo, EOtherMaintainRecord.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改维修救援等记录;
     *
     * @param bo 维修救援等记录;
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(EOtherMaintainRecordBo bo) {
        EOtherMaintainRecord update = MapstructUtils.convert(bo, EOtherMaintainRecord.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(EOtherMaintainRecord entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除维修救援等记录;信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
